/**************
/Authors: Alex & Jess 
/Company: Unicamp
/**************/

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//BIBLIOTECAS
#include <windows.h> 
#include <math.h>
#include <time.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "glut.h"
#include "glext.h" 
#include "glaux.h"
#include "glm.c"


//CLASSES
#include "Iluminacao.cpp"
#include "HUD.cpp"
#include "image.c"
#include "Texto.cpp"


using namespace std;  


//CONSTANTES

#define velocidade_fullscreen 12     //Em pcs rpidos, usar 6 e 12

#define dormencia true

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS PRINCIPAIS
void init(void);
void display(void);
void reshape (int w, int h);

void valores_iniciais();
bool ControleFPS(void);
int medidor_fps(void);



//VARIAVEIS PRINCIPAIS
int largura  = 800;                    //Dimenso da Janela
int altura = 600;
float ratio;                           //Proporo de Largura X Altura

int largura_at_full;
int altura_at_full;
            
            
int pos_x_full;
int pos_y_full;

int frameRate = 0;
int FPS_max = 29;



/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO Interface///////////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Interface();


/////////////////////////////////VARIAVEIS//////////////////////////////////////
float rcor_base_porj1 = .0;
float bcor_base_porj1 = .5;
float gcor_base_porj1 = .5;
        
float rcor_base_porj2 = .8;
float gcor_base_porj2 = .8;
float bcor_base_porj2 = .8;
        
float rcor_base_porj3 = .8;
float gcor_base_porj3 = .8;        
float bcor_base_porj3 = .8;


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE TECLADO
void keyboard_pressionar(int key,register int x,register int y);
void keyboard_soltar(int key,register int x,register int y);
void keyboard_normal(unsigned char key,register int x,register int y);
void mov_camera(int i);
void virar_camera(float ang);


//VARIAVEIS DO SISTEMA DE TECLADO
float angle=0.0, deltaAngle = 0.0;

float xx=0.0f, yy=5.0f, zz=70.0f;
float lx=0.0f, ly=0.0f, lz=-1.0f;
short deltaMove = 0;



//CONSTANTES




////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE MOUSE
void mouse_click(int button, int state, int x, int y);
void menu_click(int value);
void MoveMouse(int x, int y);

void TrataBotaoDireito();


//VARIAVEIS DO SISTEMA DE MOUSE

float x_HUD = 0;
float y_HUD = 0;


////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO LOADER
GLMmodel* drawmodel(char *string, char *type);

//VARIAVEIS DO LOADER
GLboolean clear = GL_TRUE;

GLMmodel* pmodel1 = NULL;
GLMmodel* pmodel2 = NULL;
GLMmodel* pmodel3 = NULL;
GLMmodel* pmodel4 = NULL;
GLMmodel* pmodel5 = NULL;
GLMmodel* pmodel6 = NULL;




////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//CRIANDO OBJETOS PARA OS SISTEMAS DESAJADOS

HUD HUD_System;
Texto Text_System;


//////////////////////////////Luz///////////////////////////////////
Iluminacao Light_System;

void move_luz(); 

bool dia = true;

float ang_sol  = 0;
float ang_lua  = 180;

float incr_luz = 0.5;

GLfloat intencidade_sol;
GLfloat intencidade_lua;

float ang_desl_luz = 0.35877067;
float raio_luz = 854.4003747;

float px_luz_sol;
float py_luz_sol;
float pz_luz_sol;

float px_luz_lua;
float py_luz_lua;
float pz_luz_lua;

/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DA CATAPULTA//////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////
void Catapulta();
bool AndarCatapulta();


/////////////////////////////////VARIAVEIS//////////////////////////////////////

float ang_atirador = 0.0;
float ang_catapulta = 0.0;
float x_catapulta = 0.0; 
float y_catapulta = 1.7; 
float z_catapulta = 0.0; 

float Mov_Catap = 0.1;
float Giro_Catap = 1;

float ang_roda_dir = 0;
float ang_roda_esq = 0;

float Desloc_Catap = 0;
float Virar_Catap = 0;

/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO MURO///////////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Muro();
void Colisao_portao();
void calcula_score();
void portao_caindo();

/////////////////////////////////VARIAVEIS//////////////////////////////////////
int score_portao = 300;
float ang_portao = 0;
float incr_portao = 1;
bool mov_portao = false;
bool portao = true;

int colisao = -1;

float x_muro = -200;
float y_muro = 0;
float z_muro = 0;

float h_portao = 14;
float w_portao = 17.6;


/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO PROJETIL///////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Projetil();
void Projetil1();
void Projetil2();
void Projetil3();
void MovimentoCircular();
void MovimentoProjetil();
void AtualizarCoord();

/////////////////////////////////VARIAVEIS//////////////////////////////////////
float ang_projetil =0;
int projetil = 1;
int projetil_dis;

float massa_projetil_A = 2;
float massa_projetil_B = 3;
float massa_projetil_C = 5;

int q_proj_A = 5;
int q_proj_B = 5;
int q_proj_C = 5;


float  ang_disparo = 45;
int fator = 2;

float  raio = 5.175*fator;
int div_tempo = 1000 / fator;


float  x_inicial = (x_catapulta * fator);
float  y_inicial = y_catapulta * fator;
float  z_inicial = (z_catapulta * fator);

float  x_circ_final = 0;
float  y_circ_final = 0;
float  z_circ_final = 0;

float x_projetil = x_inicial + (cos(ang_catapulta*M_PI/180)*raio);
float y_projetil = y_inicial;
float z_projetil = z_inicial - (sin(ang_catapulta*M_PI/180)*raio);

float y_projetil_final;
float x_projetil_final;
float z_projetil_final; 

float  h_final = 0;

float  Forca = 35;
float  massa = massa_projetil_A;
 

float  aceleracao = 0;
float  aceleracao_ang = 0;
float  velocidade = 0;
float  vel_vert = 0;
float  vel_horiz = 0;
float  Delta_ang = 0;
float  tempo_inicial =  0;
float  Delta_tempo = 0;

float  ang_proj = 0;
 
 
bool   mov_circ  = false;
bool   mov_proj  = false;
bool   disparar  = false;
bool   carregar = true;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////





////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE TEXTURA
void carregar_texturas(GLuint id, char *NomeArquivo);
void carregar_texturas_sprite(GLuint id, char *NomeArquivo);


//VARIAVEIS DO SISTEMA DE TEXTURA
GLuint textura[55];                        //Armazena Texturas RGB
int g_keyColor[3] = { 0, 255, 0};          //Armazena Texturas BMP para os Sprites

void SkiBox();





////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM//
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
int main(int argc, char** argv){
cout<<"Iniando Console... ";

glutInit(&argc, argv);                                      //Caminho do arquivo
glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA); //Modo de vizualizao
glutInitWindowSize (largura, altura);                              //Tamanho da janela
glutInitWindowPosition (0,0);                          //Posio da janela
if(!glutCreateWindow("NOME DO JOGO"))                     //Criar janela
    {
    MessageBox(NULL,"Falha ao criar janela.","Erro Fatal",MB_OK|MB_ICONERROR );
    return 0;
    exit(-1);
    }                                 

init ();                                                    //Inicializao principal

glutIgnoreKeyRepeat(1);                                     //Sistema de teclado
glutKeyboardFunc(keyboard_normal);
glutSpecialFunc(keyboard_pressionar);                                  
glutSpecialUpFunc(keyboard_soltar);   

glutMouseFunc(mouse_click);                                 //Sistema de Click de mouse                             

glutDisplayFunc(display);                                   //Desenho (Render)

glutIdleFunc(display);                                      //Funo callback de Render
glutReshapeFunc(reshape);                                   //Redimensionar Janela
glutMainLoop();                                             //Loop principal

return TRUE;
}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void init(void)
{    
//MODELOS
cout<<"(OK)\nCarregando modelos 3D";  

pmodel1=drawmodel("models/Catapulta_Base.obj","texture");cout<<"."; 
pmodel2=drawmodel("models/Atirador.obj","texture");cout<<"."; 
pmodel3=drawmodel("models/Pedra.obj","texture");cout<<"."; 
pmodel4=drawmodel("models/Roda_Composta.obj","texture");cout<<"."; 
pmodel5=drawmodel("models/Castelo.obj","texture");cout<<"."; 
pmodel6=drawmodel("models/Portao.obj","texture");cout<<"."; 

//CARREGANDO TEXTURAS
cout<<"(OK)\nCarregando texturas...";  
carregar_texturas(1,"textures/ceu_dia.rgb");cout<<".";  
carregar_texturas(2,"textures/ceu_noite.rgb");cout<<".";  
 

//INICIANDO CONFIGURACOES PADROES
cout<<" (OK)\nDefinindo configuracoes iniciais... ";  

glClearColor (0, 0, 0, 0);                  //Cor de fundo
valores_iniciais();

cout<<"(OK)";  
Light_System.create();


}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void display(void)
{ 	     
 
/***************
/VARIAVEIS
/***************/
static GLUquadricObj *quadric = gluNewQuadric();    //Iniciando objetos Quadrics

medidor_fps();       

if(ControleFPS()){

    if (deltaMove)
    	mov_camera(deltaMove);
    if (deltaAngle) 
        {
    	angle += deltaAngle;
    	virar_camera(angle);
    	}
   	if(Desloc_Catap){
        
        bool andou = AndarCatapulta();
        if(andou)if(Desloc_Catap>0){
             ang_roda_dir -= Mov_Catap*(14*fator);
             ang_roda_esq -= Mov_Catap*(14*fator);
        }else{
             ang_roda_dir += Mov_Catap*14*fator;
             ang_roda_esq += Mov_Catap*14*fator;
        }
        
        if(!disparar){
           AtualizarCoord();
        }
     
    
    if(Virar_Catap){
          
        float ang_aux = 0;
                  
        if(Desloc_Catap>0)            
             ang_aux = Virar_Catap * -1;
        else
             ang_aux = Virar_Catap;
            
        ang_catapulta += ang_aux;
            
        float mult = 1;
        if(Virar_Catap>0){
             ang_roda_dir -= Giro_Catap*mult*fator;
             ang_roda_esq += Giro_Catap*mult*fator;
        }else{
             ang_roda_dir += Giro_Catap*mult*fator;
             ang_roda_esq -= Giro_Catap*mult*fator;
        }
        
        if(!disparar){
           AtualizarCoord();
        }
      }
    }
    
    /***************
    /CFG INICIAL
    /***************/
    
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        //Limpando buffers
  
    glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);   //Definindo filtro de textura
    gluQuadricTexture(quadric, GL_TRUE);                        //Ativando Texturizao de quadrics

    
    glEnable(GL_BLEND);                                         //habilita as funes transparencia
    glEnable(GL_ALPHA_TEST);                                    //Habilita o rotacao_animacao alpha
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);           //Define como  feita a mistura de cor para o alpha
    glEnable(GL_AUTO_NORMAL);                                   //Gerar normais automatimaticamente
    glEnable(GL_NORMALIZE);  
    glEnable(GL_DEPTH_TEST);                                    //TESTA PROFUNDIDADE P/ EXIBIR SEM SOBREPOSICAO
    glShadeModel(GL_SMOOTH);                                    //SECIONA O TIPO DE SHADER. EX: GL_FLAT
    
    glCullFace(GL_BACK); 
    

    glPushMatrix();
    
                   
                      
        glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
        
        move_luz();
        Light_System.move_luz(px_luz_sol,py_luz_sol,pz_luz_sol,px_luz_lua,py_luz_lua,pz_luz_lua);
        
        glPushMatrix();
            glTranslatef(px_luz_sol,py_luz_sol,pz_luz_sol);  
            glScalef(10,10,10);
            glColor3f(0,1,1);
            glutSolidSphere(1, 15, 15);
        glPopMatrix();
        
        glPushMatrix();
            glTranslatef(px_luz_lua,py_luz_lua,pz_luz_lua);  
            glScalef(10,10,10);
            glColor3f(.9,.9,.9);
            glutSolidSphere(1, 15, 15);
        glPopMatrix();
        
        
        glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
    glPopMatrix();
    
    Light_System.ControlaLuz(intencidade_sol,intencidade_lua);
    glEnable(GL_LIGHTING);   //Ligando Luz
    
    glEnable(GL_LIGHT2);
    glEnable(GL_LIGHT1);
    glEnable(GL_LIGHT0);       

    SkiBox();

    Projetil();   
    Catapulta();
    
    Muro();
          
    
    
    
        glBegin(GL_POLYGON); 
                if(dia)
                       Light_System.set_material(0.0,0.7,0.0,.4+(.6*intencidade_sol),0,0,'d');
                else
                       Light_System.set_material(0.0,0.7,0.0,.4-(.25*intencidade_lua),0,0,'d');
                //glColor3f(0,.5,0);
                glVertex3f(-400,0.0,-400);
                glVertex3f(-400,0.0, 400);
                //glColor3f(0,.7,0);
                if(dia)
                       Light_System.set_material(0.0,0.7,0.0,.4+(.6*intencidade_sol),0,0,'d');
                else
                       Light_System.set_material(0.0,0.7,0.0,.4-(.25*intencidade_lua),0,0,'d');
                glVertex3f( 400,0.0, 400);
                glVertex3f( 400,0.0,-400); 
        glEnd();
    
    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHT1);
    glDisable(GL_LIGHT2);
    glDisable(GL_LIGHTING); 

       
    Interface();   

    
    glFlush();			  
    glutSwapBuffers();  
}
}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void reshape (int w, int h)
{
  	if(h == 0)                       
		h = 1;
    
    largura = w;
    altura = h;
    
    
	ratio = 1.0f * largura / altura;
	
	glMatrixMode(GL_PROJECTION);     
	glLoadIdentity();
  
    glViewport(0, 0, w, h);          
	gluPerspective(45,ratio,1,2000);                  
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST); 
    
    
    glMatrixMode(GL_MODELVIEW);    
	glLoadIdentity();
	gluLookAt(xx,      yy,      zz,   
		      xx + lx, yy + ly, zz + lz,
			  0.0f,   1.0f,   0.0f);
			  
                
}  


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//TECLADO
void keyboard_pressionar(int key,register int x,register int y) {


	switch (key) 
    {
       
		case GLUT_KEY_INSERT : deltaAngle = -0.045f;
        break;
		
        case GLUT_KEY_PAGE_UP : deltaAngle = 0.045f;
        break;
		
        case GLUT_KEY_HOME : 

            deltaMove = velocidade_fullscreen;
      
        break;
		
        case GLUT_KEY_END :
    
            deltaMove = -velocidade_fullscreen;
        
        break;
        
        case GLUT_KEY_UP:
            if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Desloc_Catap =  -Mov_Catap;
        
        break;
        
        case GLUT_KEY_DOWN:
             if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Desloc_Catap =  Mov_Catap;
        
        break;
 
        case GLUT_KEY_LEFT:
            if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Virar_Catap =  Giro_Catap;
        break;
        case GLUT_KEY_RIGHT:
            if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Virar_Catap =  -Giro_Catap;

        break;
 
        

   }

//cout<<"\nTecla pressionada: "<< key<<"\n";


}

void keyboard_soltar(int key,register int x,register int y) 
{
     
	switch (key) 
    {
		case GLUT_KEY_HOME: 
		case GLUT_KEY_END: 
             deltaMove = 0;
        break;	
        
		case GLUT_KEY_INSERT: 
		case GLUT_KEY_PAGE_UP: 
             deltaAngle = 0.0f;
        break;
        
        case GLUT_KEY_UP:       
        case GLUT_KEY_DOWN:
    
            Desloc_Catap = 0;
        
        break;
        
        case GLUT_KEY_LEFT:
        case GLUT_KEY_RIGHT:
                   Virar_Catap =  0;
        break;
        case GLUT_KEY_F1:
            
            static bool flag_full = false; 
            
            
            
            if (!flag_full){
                 largura_at_full= largura;
                 altura_at_full = altura;
            
                 pos_x_full = GLUT_WINDOW_X;
                 pos_y_full = GLUT_WINDOW_Y;
                 
                 glutFullScreen();
                 
                 flag_full=!flag_full;
                 
            }else{
			     glutReshapeWindow(largura_at_full,altura_at_full);
                 glutPositionWindow(20,20); 
                 flag_full=!flag_full;
            }
        break;
	}
	
//cout<<"\nTecla Solta: "<< key<<"\n";	

}

void keyboard_normal(unsigned char key,register int x,register int y) 
{

	switch (key) 
    {
        
        
		case 'r' :        
		case 'R' : 
	             carregar  = true;
                 disparar  = false;
                 mov_circ  = false;
                 mov_proj  = false;
                 
                 AtualizarCoord();
                 
                 tempo_inicial = 0;
                 Delta_ang = 0;
                 ang_atirador = 0;
                 
                 q_proj_A = 5;
                 q_proj_B = 5;
                 q_proj_C = 5;
                 
                 colisao =-1;   
                 score_portao = 300;
                 ang_portao = 0;
                 mov_portao = false;
                 portao = true;
                 
                 valores_iniciais();
	         
        break;
        
        case 'd' : 
        case 'D' :
             if (carregar){
                int proj_existe = 0; 
                switch (projetil){
                         
                     case 1 : if(q_proj_A>0)proj_existe =1;
                     break;
                          
                     case 2 : if(q_proj_B>0)proj_existe =1;
                     break;
                          
                     case 3 : if(q_proj_C>0)proj_existe =1;
                     break;
                          
                } 
                projetil_dis =  projetil;       
    	        if(proj_existe){
                    disparar  = true;
    	            carregar = false;
    	            switch (projetil){
                         
                          case 1 : q_proj_A--;
                          break;
                          
                          case 2 : q_proj_B--;
                          break;
                          
                          case 3 : q_proj_C--;
                          break;
                          
                    } 
                 }
             }
        break;
        
        
        case 'c' : 
        case 'C' :
             if (disparar && mov_circ && mov_proj && !mov_portao){
                 carregar  = true;
                 disparar  = false;
                 mov_circ  = false;
                 mov_proj  = false;
                 
                 AtualizarCoord();
                 
                 tempo_inicial = 0;
                 Delta_ang = 0;
                 ang_atirador = 0;      
                 
                 colisao =-1;    
                 
                 projetil =  projetil_dis;        
                 
             }
        break;
        
        case 'A' :
             if (ang_disparo >= 0){
                 ang_disparo -= 0.5 ;
                 cout<<"\nAngulo de Disparo: " << ang_disparo;
             }else{
                cout<<"\nO angulo maximo de disparo  de 90.\nAngulo de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'a' : 
             if (ang_disparo < 90 ){
                 ang_disparo += 0.5 ;
                 cout<<"\nAngulo de Disparo: " << ang_disparo;
             }else{
                cout<<"\nO angulo minimo de disparo  de 0.\nAngulo de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'F' :
             if (Forca >= 10){
                 Forca -= 0.5 ;
                 cout<<"\nFora de Disparo: " << Forca;
             }else{
                cout<<"\nA fora maxima de disparo  de 80N.\nFora de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'f' : 
             if (Forca < 90){
                 Forca += 0.5 ;
                 cout<<"\nFora de Disparo: " << Forca;
             }else{
                cout<<"\nA fora minima de disparo  de 10N.\nFora de Disparo Atual: " << ang_disparo; 
             }
        break;
        

        
        case '1' : Projetil1();
            
        break;
        
        case '2' : Projetil2();
         
        break;
        
        case '3' : Projetil3();
           
        break;
        
        case 27 : 
             exit(0);
        break;
        
	}

//cout<<"\nTecla Normal: "<< key<<"\n";

}   


void mouse_click(int button, int state, int x, int y) 
{  
    x_HUD = (float)x/(float)largura;
    y_HUD = 1-((float)y/(float)altura);
    //cout<<"\n Button: "<<button<<" - State: "<<state<<" - X: "<< x <<" = "<< x_HUD<<" - Y: "<<y<<" = "<< y_HUD<<"\n";
	if(state == GLUT_DOWN && button==0){
             
             TrataBotaoDireito();
		
	} 
		
	
}

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 
void virar_camera(float ang) 
{

lx = sin(ang);
lz = -cos(ang);
glLoadIdentity();
gluLookAt(xx,     yy,     zz, 
		  xx + lx,yy + ly,zz + lz,
		  0.0f,  1.0f,  0.0f);
}


//////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////// 
void mov_camera(int i) 
{                   

xx = xx + (i*lx*0.1);
zz = zz + (i*lz*0.1);


glLoadIdentity();  

gluLookAt(xx     ,yy     ,zz, 
		      xx + lx, yy + ly, zz + lz,
		      0.0f   ,1.0f   ,0.0f);
        

}   

 

     
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////         
GLMmodel* drawmodel(char *string, char *type)
{
    GLMmodel* pmodel = NULL;
    if (!pmodel) {
        pmodel = glmReadOBJ(string);
        if (!pmodel) exit(0);
        glmFacetNormals(pmodel);
        glmVertexNormals(pmodel, 0);
    }    

return pmodel;
}




//****************************************************************************//
//////////////////////////Catapulta/////////////////////////////////////////////

void Catapulta(){


//Light_System.set_material(1.0,.5,1.0,1.0);

glPushMatrix(); 
    
    
    
    
    glScalef(fator,fator,fator); 
    glTranslatef(x_catapulta, y_catapulta, z_catapulta);  
    glRotatef(ang_catapulta,0,1,0);
     
    glPushMatrix(); 
       Light_System.set_material(1.0,.5,1.0,1.0,0.0,0.0,'d');
       //glColor3f(1,.5,1);
       glTranslatef(-3.25,-0.7,2.5);
       glRotatef(ang_roda_dir,0,0,1);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    glPushMatrix(); 
       Light_System.set_material(1.0,.5,1.0,1.0,0,0,'d');
       //glColor3f(1,.5,1);
       glTranslatef(3.25,-0.7,2.5);
       glRotatef(ang_roda_dir,0,0,1);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    
    
    glPushMatrix(); 
       Light_System.set_material(1.0,0.0,0.0,1.0,0,0,'d');
       //glColor3f(1,0,0);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix(); 
    
    
    glPushMatrix();
        Light_System.set_material(1.0,1.0,0.0,1.0,0,0,'d');
        //glColor3f(1,1,0); 
        glRotatef(ang_atirador,0,0,1);
	    glmDraw(pmodel2, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();   

      
    glPushMatrix(); 
       Light_System.set_material(1.0,.5,1.0,1.0,0,0,'d');
       //glColor3f(1,.5,1);
       glTranslatef(-3.25,-0.7,-2.5);
       glRotatef(ang_roda_esq,0,0,1);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    glPushMatrix(); 
       Light_System.set_material(1.0,.5,1.0,1.0,0,0,'d');
       //glColor3f(1,.5,1);
       glTranslatef(3.25,-0.7,-2.5);
       glRotatef(ang_roda_esq,0,0,1);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    

glPopMatrix();

     
}

//****************************************************************************//
/////////////////////////////////////PROJETIL///////////////////////////////////

void Projetil(){     


glPushMatrix();
    
    if((colisao == -1) && disparar){
         Colisao_portao();                    
    }

    if(disparar && !mov_circ){
         MovimentoCircular();
    }
    
    if(disparar && mov_circ && !mov_proj){
          MovimentoProjetil();
    }
    
    
    glTranslatef(x_projetil,y_projetil,z_projetil);
    
    if(!mov_proj && mov_circ)
          ang_proj += 5;
    glRotatef(ang_proj,1,1,1);
    
    
    	switch (projetil) 
    {
		case 1: if(q_proj_A || (disparar && !q_proj_A)){
                  glScalef(.25*fator,.25*fator,.25*fator);
                  Light_System.set_material(0.0,0.0,1.0,1.0,.8,0,'d');
    		      //glColor3f(0,0,1);
                  glutSolidSphere(1, 100, 100);
              }
              
        break;	
        
		case 2: if(q_proj_B  || (disparar && !q_proj_B)){
                  glScalef(.25*fator,.4*fator,.325*fator);
                  Light_System.set_material(0.0,1.0,1.0,1.0,.8,0,'d');
    		      //glColor3f(0,1,1);
                  glutSolidSphere(1, 100, 100);
              }
        break;
        
        case 3: if(q_proj_C  || (disparar && !q_proj_C)){
                  glScalef(.4*fator,.4*fator,.4*fator);
                  Light_System.set_material(1.0,0.0,1.0,1.0,.8,0,'d');
    		      //glColor3f(1,0,1);
    	          glmDraw(pmodel3, GLM_TEXTURE | GLM_SMOOTH );
              }             
        break;
	}
    

glPopMatrix();


     
};

////////////////////////////////////////////////////////////////////////////////
void MovimentoCircular(){ 
      Desloc_Catap = 0;  
      
      
      if(tempo_inicial == 0){
            tempo_inicial = timeGetTime ();      
      }
      Delta_tempo = timeGetTime() - tempo_inicial;
      
      Delta_tempo = Delta_tempo / div_tempo;
      
      Delta_ang = (aceleracao_ang * Delta_tempo * Delta_tempo)/2;
  
   if( Delta_ang <= (ang_disparo*M_PI/180)){ 
       
      float dist = (cos(Delta_ang) * (raio));
      y_projetil = (sin(Delta_ang) * (raio))+ y_inicial;
      x_projetil = x_inicial + (cos(ang_projetil * M_PI/180)*dist);
      z_projetil = z_inicial - (sin(ang_projetil * M_PI/180)*dist);
      
      ang_atirador = Delta_ang / M_PI * 180;
      
   }else {
          ang_atirador = ang_disparo; 
            
          tempo_inicial = 0;  
           
          mov_circ = true;         
   }
};
////////////////////////////////////////////////////////////////////////////////
void MovimentoProjetil(){
      
      if(y_projetil >= h_final && !mov_proj){  
      
          if(tempo_inicial == 0){
              tempo_inicial = timeGetTime ();      
          }
          Delta_tempo = timeGetTime() - tempo_inicial;
          
          Delta_tempo = Delta_tempo / div_tempo;
          
          float dist = ( vel_horiz * Delta_tempo );
          y_projetil = y_circ_final + ( vel_vert * Delta_tempo ) + ( -9.8 * (Delta_tempo * Delta_tempo) / 2 );
          
          x_projetil = x_circ_final - (cos(ang_projetil * M_PI/180)*dist);
          z_projetil = z_circ_final + (sin(ang_projetil * M_PI/180)*dist);
          
          if(x_projetil <= x_muro && colisao == 1 && portao){
          
              x_projetil = x_projetil_final;
              y_projetil = y_projetil_final;
              z_projetil = z_projetil_final;
              
              calcula_score();
      
              mov_proj = true;
          
          }
          
      }else {
            
          y_projetil = h_final;
          mov_proj = true;
          
      }
};


void Projetil1(){

             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 1;
                  massa = massa_projetil_A;
                  
                  rcor_base_porj1 = .0;
                  bcor_base_porj1 = .5;
                  gcor_base_porj1 = .5;     
                     
                  rcor_base_porj2 = gcor_base_porj2 = bcor_base_porj2 = .8;
                  rcor_base_porj3 = gcor_base_porj3 = bcor_base_porj3 = .8;
                  
                  cout<<"\nProjetil A selecionado. Massa do Projetil: " << massa; 
             }
};

void Projetil2(){
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 2;
                  massa = massa_projetil_B;
                  
                  rcor_base_porj2 = .0;
                  bcor_base_porj2 = .5;
                  gcor_base_porj2 = .5;
        
                  rcor_base_porj1 = gcor_base_porj1 = bcor_base_porj1 = .8;
                  rcor_base_porj3 = gcor_base_porj3 = bcor_base_porj3 = .8;
                       
                  cout<<"\nProjetil B selecionado. Massa do Projetil: " << massa; 
             }
     
};

void Projetil3(){
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 3;
                  massa = massa_projetil_C;
                  
                  rcor_base_porj3 = .0;
                  bcor_base_porj3 = .5;
                  gcor_base_porj3 = .5;
        
                  rcor_base_porj1 = gcor_base_porj1 = bcor_base_porj1 = .8;
                  rcor_base_porj2 = gcor_base_porj2 = bcor_base_porj2 = .8;
                       
                  cout<<"\nProjetil C selecionado. Massa do Projetil: " << massa; 
             }
     
};

//****************************************************************************//
/////////////////////////////////////Muro///////////////////////////////////////
void Muro(){
     
glPushMatrix();        
     glTranslatef(x_muro,y_muro,z_muro);
     glScalef(fator,fator,fator);
     
    glPushMatrix(); 
       Light_System.set_material(0.5,0.4,0.3,1.0,0.0,0.0,'d');
       //glColor3f(.5,.4,.3);
	   glmDraw(pmodel5, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    if(mov_portao){
        cout<<"\nPassou";
        ang_portao -= incr_portao;
        if(ang_portao<=-90){
            ang_portao = -90;
            mov_portao = false;
            portao = false;
        }
    
    }
    
    glPushMatrix(); 
       Light_System.set_material( 0.7,  0.6,  0.5, 1.0,
                                  0.7,  0.6,  0.5, 1.0,
                                    0,    0,    0, 1.0,
              .7*intencidade_lua,    .6*intencidade_lua,    .5*intencidade_lua, 1.0,
                        20,  'd');
                        
       //set_material(0.7,0.6,0.5,1.0,0.0,.5*intencidade_lua,'d'); 
       //glColor3f(.7,.6,.5);
       glRotatef(ang_portao,0,0,1);
	   glmDraw(pmodel6, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
     

     
glPopMatrix();
};

void Colisao_portao(){
     
     ang_projetil = ang_catapulta;
     
     aceleracao = Forca * massa;
     aceleracao_ang = aceleracao/raio;
     
     float dist = (cos(ang_disparo * M_PI / 180) * (raio));
     y_circ_final = (sin(ang_disparo * M_PI / 180) * (raio))+ y_inicial;
     x_circ_final = x_inicial + (cos(ang_projetil * M_PI/180)*dist);
     z_circ_final = z_inicial - (sin(ang_projetil * M_PI/180)*dist);
          
     velocidade  = aceleracao*(sqrt(2*(ang_disparo*M_PI/180)/aceleracao_ang)); 
     vel_horiz =  cos((90-ang_disparo)*M_PI/180) * velocidade;
     vel_vert  =  sin((90-ang_disparo)*M_PI/180) * velocidade;
     
     dist = (x_circ_final - x_muro)/(cos(ang_projetil * M_PI/180));
     
     Delta_tempo = dist / vel_horiz;
     
     cout<<"\nDist: "<< dist<<" Tempo: "<<Delta_tempo;
     
     y_projetil_final = y_circ_final + ( vel_vert * Delta_tempo ) + ( -9.8 * (Delta_tempo * Delta_tempo) / 2 );
     x_projetil_final = x_circ_final - (cos(ang_projetil * M_PI/180)*dist);
     z_projetil_final = z_circ_final + (sin(ang_projetil * M_PI/180)*dist);
     
     cout<<"\nX: "<< x_projetil_final<<" Y: "<<y_projetil_final<<" Z: "<<z_projetil_final;;
     
     if(Delta_tempo>0){                 
            if (y_projetil_final <= h_portao*fator&& y_projetil_final >= h_final){    
                 if (z_projetil_final >= -w_portao && z_projetil_final <= w_portao){
                      colisao = 1;  
                      //cout<<"\n\nVoce acertou o muro, voce acertou "<< acertos<<" vezes.\n";      
                           //mov_circ = true; 
                           //mov_proj = true;
                           
                 }else{
                       colisao = 0;
                 }
            }else{
                  colisao = 0;
           }
                 
     }else{
           colisao = 0;
     }
     
}

void valores_iniciais(){
     srand(timeGetTime());

     Forca = 80 - rand()%70;
     ang_disparo =  90 - rand()%70;
     
     ang_catapulta =  rand() % 360;
     x_catapulta = 20 - rand()%40;
     z_catapulta = 20 - rand()%40;
     
     AtualizarCoord();
     
     cout<<"\nAngulo: "<<ang_disparo;
     cout<<"\nFora: "<<Forca;
     cout<<"\nMuro: "<<x_muro;
};


//****************************************************************************//
////////////////////////////////Controle FPS////////////////////////////////////

bool ControleFPS(void){
     
     
    static int counter_ciclo = 0;
    static int timer_aux = timeGetTime ();
    static int DELAY  = 1000/FPS_max;
      
    if((timeGetTime()- timer_aux)< DELAY  && dormencia)
          Sleep(DELAY - (timeGetTime() - timer_aux));
          
    if ((timeGetTime()- timer_aux)>DELAY) {
           
       counter_ciclo++;
       timer_aux = timeGetTime ();	
       int aux_fps = FPS_max;
       
       if(counter_ciclo >= aux_fps){
           //cout <<"\nFPS Ciclos: "<< counter_ciclo<<"\nDelay: "<< DELAY <<"\n";  
           counter_ciclo = 0;               
       }
       
       return true;
    }         
    return false;
};

int medidor_fps()
{	
    	
    static int counter = 0;	counter++;	
    static unsigned int timer = timeGetTime ();	
    if (timeGetTime() > (timer + 1000)){		
        frameRate = counter;		
        counter = 0;		
        timer = timeGetTime ();	
        //cout <<"\nFPS Medidor: "<<frameRate<<"\n";
    }
    return frameRate;
}

////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void AtualizarCoord(){
     x_inicial = x_catapulta * fator;
     y_inicial = y_catapulta * fator;
     z_inicial = z_catapulta * fator;
        
     x_projetil = x_inicial + (cos(ang_catapulta*M_PI/180)*raio);
     y_projetil = y_inicial;
     z_projetil = z_inicial - (sin(ang_catapulta*M_PI/180)*raio); 
};


bool AndarCatapulta(){
     
     float x_aux = x_catapulta + cos(ang_catapulta*M_PI/180)*Desloc_Catap;
     float z_aux = z_catapulta - sin(ang_catapulta*M_PI/180)*Desloc_Catap;
     
     if(z_aux > -25 && z_aux < 25 && x_aux > -25 && x_aux < 25){
         x_catapulta = x_aux;
         z_catapulta = z_aux;
         return true;
     }
     return false;
};

////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void Interface(){

/***************
/CRIANDO HUD
/***************/
    glPushMatrix();
    HUD_System.enable(largura,altura);
        
         
        glBegin(GL_QUADS); 
             glColor4f(1,1,1,.3);
             //glTexCoord2f(1,0);            
             glVertex3f(0,.93,0);               
             //glTexCoord2f(0,0);
             glVertex3f(1,.93,0); 
             //glTexCoord2f(0,1);
             glColor4f(1,1,1,1);
             glVertex3f(1,1,0);
             //glTexCoord2f(1,1);
             glVertex3f(0,1,0); 
        glEnd();
        
        
        static int ang_proj_inter = 0;
        ang_proj_inter += 10;   

        
        
        glBegin(GL_QUADS); 
             glColor3f(rcor_base_porj1,gcor_base_porj1,bcor_base_porj1);
             //glTexCoord2f(1,0);            
             glVertex3f(.01,.94,0);               
             //glTexCoord2f(0,0);
             glVertex3f(.01,.995,0); 
             //glTexCoord2f(0,1);
             glVertex3f(.05,.995,0);
             //glTexCoord2f(1,1);
             glVertex3f(.05,.94,0); 
        glEnd();   
    
    	glPushMatrix();
              glTranslatef(.03,.98,0);
              glRotatef(ang_proj_inter,1,1,1);
              glScalef(.01,.01,.01);
		      glColor3f(0,0,1);
              glutSolidSphere(1, 100, 100);
        glPopMatrix(); 	
        
        
        glBegin(GL_QUADS); 
             glColor3f(rcor_base_porj2,gcor_base_porj2,bcor_base_porj2);
             //glTexCoord2f(1,0);            
             glVertex3f(.055,.94,0);               
             //glTexCoord2f(0,0);
             glVertex3f(.055,.995,0); 
             //glTexCoord2f(0,1);
             glVertex3f(.095,.995,0);
             //glTexCoord2f(1,1);
             glVertex3f(.095,.94,0); 
        glEnd();  
        
		glPushMatrix(); 
              glTranslatef(.075,.98,0);
              glRotatef(ang_proj_inter,1,1,1);
              glScalef(.00625,.01,.008125);
		      glColor3f(0,1,1);
              glutSolidSphere(1, 100, 100);
        glPopMatrix(); 
        
        glBegin(GL_QUADS); 
             glColor3f(rcor_base_porj3,gcor_base_porj3,bcor_base_porj3);
             //glTexCoord2f(1,0);            
             glVertex3f(.1,.94,0);               
             //glTexCoord2f(0,0);
             glVertex3f(.1,.995,0); 
             //glTexCoord2f(0,1);
             glVertex3f(.14,.995,0);
             //glTexCoord2f(1,1);
             glVertex3f(.14,.94,0); 
        glEnd();
        
        glPushMatrix();
              glTranslatef(.12,.98,0);
              glRotatef(ang_proj_inter,1,1,1);
              glScalef(.01,.01,.01);
		      glColor3f(1,0,1);
	          glmDraw(pmodel3, GLM_TEXTURE | GLM_SMOOTH );             
       glPopMatrix();
          
       //Medidor de FPS  
       glColor3f(0,0,0);  
       char exibir[50];           
       sprintf(exibir, "%i", score_portao );
       Text_System.draw2d("Portao:",.8,.95,2);
       Text_System.draw2d(exibir,.90,.95,2);
       
       
       sprintf(exibir, "%i", q_proj_A);
       Text_System.draw2d(exibir,.025,.945,2);
       sprintf(exibir, "%i", q_proj_B);
       Text_System.draw2d(exibir,.07,.945,2);
       sprintf(exibir, "%i", q_proj_C);
       Text_System.draw2d(exibir,.115,.945,2);
       
       
       Text_System.draw2d("Angulo",.4,.97,2);
       sprintf(exibir, "%f", ang_disparo);
       Text_System.draw2d(exibir,.5,.97,2);
       
       Text_System.draw2d("Forca",.4,.94,2);
       sprintf(exibir, "%f", Forca);
       Text_System.draw2d(exibir,.5,.94,2);
       
            
    HUD_System.disable(ratio,xx,yy,zz,lx,ly,lz);
    glPopMatrix(); 
     
};


void TrataBotaoDireito(){
     
     if(y_HUD >= 0.94 && y_HUD <= 0.995){
               
              if(x_HUD >= 0.01 && x_HUD <= 0.05){
                       
                       Projetil1();                       
                       
              }
              if(x_HUD >= 0.055 && x_HUD <= 0.095){
                       
                       Projetil2();
                       
                       
              }
              if(x_HUD >= 0.1 && x_HUD <= 0.14){
                       
                       Projetil3();
                       
                       
              }
     }
     
};


void SkiBox(){


glEnable(GL_TEXTURE_2D);  
int text = 1;
if(!dia)
text = 2;


                       
glBindTexture(GL_TEXTURE_2D,textura[text]);
if(dia)
       Light_System.set_material(0.5,0.5,0.5,.4+(.6*intencidade_sol),0,0,'d');
else
       Light_System.set_material(0.5,0.5,0.5,1,0,0,'d');
       
//CRIANDO SKYBOX
glPushMatrix();
    glBegin(GL_QUADS); 
        glTexCoord2f(1,0);            
        glVertex3f(-500,-10,-505);               
        glTexCoord2f(0,0);
        glVertex3f(-500,-10,+505); 
        glTexCoord2f(0,1);
        glVertex3f(-500,+500,+505);
        glTexCoord2f(1,1);
        glVertex3f(-500,+500,-505);
   glEnd();   
glPopMatrix();
 
glPushMatrix();
    glBegin(GL_QUADS); 
        glTexCoord2f(0,0);            
        glVertex3f(+500,-10,-505);               
        glTexCoord2f(1,0);
        glVertex3f(+500,-10,+505); 
        glTexCoord2f(1,1);
        glVertex3f(+500,+500,+505);
        glTexCoord2f(0,1);
        glVertex3f(+500,+500,-505);


   glEnd(); 
glPopMatrix();

glPushMatrix();
    glBegin(GL_QUADS); 
        glTexCoord2f(1,0);            
        glVertex3f(-505,-10,-500);
        glTexCoord2f(0,0);
        glVertex3f(+505,-10,-500);
        glTexCoord2f(0,1);
        glVertex3f(+505,+500,-500);
        glTexCoord2f(1,1);
        glVertex3f(-505,+500,-500); 
   glEnd(); 
glPopMatrix();  

glPushMatrix();

   glBegin(GL_QUADS); 
        glTexCoord2f(0,0);            
        glVertex3f(-505,-10,+500);
        glTexCoord2f(1,0);
        glVertex3f(+505,-10,+500);
        glTexCoord2f(1,1);
        glVertex3f(+505,+500,+500);
        glTexCoord2f(0,1);
        glVertex3f(-505,+500,+500); 
   glEnd(); 

glPopMatrix(); 

glDisable(GL_TEXTURE_2D);  

}


void carregar_texturas(GLuint id, char *NomeArquivo)
{

IMAGE *img;
GLenum gluerr;
glGenTextures(1, &textura[id]);
glBindTexture(GL_TEXTURE_2D, textura[id]);
  
if(!(img=ImageLoad(NomeArquivo))) 
    {
    MessageBox(NULL,"Falha ao encontrar texturas.","Erro Fatal",MB_OK|MB_ICONERROR ); 
    exit(-1); 
    }

gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D, 3, img->sizeX, img->sizeY, GL_RGB, 
                             GL_UNSIGNED_BYTE, (GLvoid *)(img->data));
			   
if(gluerr)
    {
    MessageBox(NULL,"Falha ao criar mipmaps.","Erro Fatal",MB_OK|MB_ICONERROR ); 
    exit(-1);
    }

glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST );
glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); 
}

void move_luz(){
    
    if(ang_sol <=(360-incr_luz)){     
          ang_sol += incr_luz;
          ang_lua += incr_luz;
    }else{
          ang_sol =   0;
          ang_lua = 180;
    }
    
    if(ang_sol >= 0 && ang_sol <180)
               dia = true;
    else
               dia = false;
    
    intencidade_sol = sin(((ang_sol+5)/190*180)*M_PI/180);
    if(intencidade_sol<0)
       intencidade_sol = 0;
    
    intencidade_lua = sin(((ang_lua+5)/190*180)*M_PI/180);
    if(intencidade_lua<0)
       intencidade_lua = 0;
    
    //cout<<"\nSol = "<<intencidade_sol<<" - Lua = "<<intencidade_lua;
    
    
    py_luz_sol = (sin(ang_sol*M_PI/180)*raio_luz);
    
    float dist = cos(ang_sol*M_PI/180)*raio_luz;
    px_luz_sol = 0 + sin(ang_desl_luz)*dist; 
    pz_luz_sol = 0 - cos(ang_desl_luz)*dist;
    
    
    py_luz_lua = (sin(ang_lua*M_PI/180)*raio_luz);
    
    dist = cos(ang_lua*M_PI/180)*raio_luz;
    
    px_luz_lua = 0 + sin(ang_desl_luz)*dist; 
    pz_luz_lua = 0 - cos(ang_desl_luz)*dist;
    
    
     
    
    //cout<<"\nX: "<<px_luz << " - Y: " << py_luz<< " - Z: "<<pz_luz;
    
}; 

void calcula_score(){
     switch (projetil){
                         
         case 1 : score_portao -= 60;
         break;
                          
         case 2 : score_portao -= 100;
         break;
                          
         case 3 : score_portao -= 150;
         break;
                          
     } 
     if(score_portao <= 0){
           score_portao = 0;
           projetil = -1;
           mov_portao = true;
           
     }

};



